summaryrefslogtreecommitdiff
path: root/tests/chown/basic
diff options
context:
space:
mode:
Diffstat (limited to 'tests/chown/basic')
-rwxr-xr-xtests/chown/basic69
1 files changed, 69 insertions, 0 deletions
diff --git a/tests/chown/basic b/tests/chown/basic
new file mode 100755
index 0000000..39fad14
--- /dev/null
+++ b/tests/chown/basic
@@ -0,0 +1,69 @@
+#!/bin/sh
+# make sure chown --from=... works
+
+# Copyright (C) 2001, 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chgrp --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+PRIV_CHECK_ARG=require-root . $srcdir/../priv-check
+
+pwd=`pwd`
+tmp=basic.$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+touch f || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework' 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+chown -R --preserve-root 0:1 f
+
+# Make sure the owner and group are 0 and 1 respectively.
+set _ `ls -n f`; shift; test "$3:$4" = 0:1 || fail=1
+
+chown --from=0:1 2:010 f || fail=1
+
+# And now they should be 2 and 10 respectively.
+set _ `ls -n f`; shift; test "$3:$4" = 2:10 || fail=1
+
+ln -s f slink
+# Applying chown to a symlink with --no-dereference
+# should change only the link.
+chown --no-dereference 0:1 slink || fail=1
+# owner/group on the symlink should be set
+set _ `ls -n slink`; shift; test "$3:$4" = 0:1 || fail=1
+# owner/group on the referent should remain unchanged
+set _ `ls -n f`; shift; test "$3:$4" = 2:10 || fail=1
+
+chown --no-dereference --from=0:1 2:010 slink || fail=1
+# owner/group on the symlink should be changed
+set _ `ls -n slink`; shift; test "$3:$4" = 2:10 || fail=1
+
+(exit $fail); exit $fail